//
//	$Date: 2001/05/30 08:57:32 $
//	$Revision: 1.2 $
//

#include <PalmOS.h>
#include "pwprefs.h"
#include "savelink.h"

//
//	Save current application's information into PalmWiki's
//	preferences database
//
static void SaveLink()
{
	DmOpenRef db,datadb;
	LocalID id;
	UInt16 cardno;
	UInt32 type,creator;
	UInt16 i,n;
	UInt16 attr;

	WikiPref pref;
	Link *link;

	if(!GetWikiPreferences(&pref,false)){
		 return; // no PalmWiki found
	}

	link = &(pref.linkstack[pref.linkstackindex]);
	link->appid = link->dataid = NULL;
	link->appcardno = link->datacardno = 0;
	link->recordno = 0xffff;

	datadb = NULL;
	db = DmNextOpenDatabase(NULL);
	while(db){
		DmOpenDatabaseInfo(db,&id,
			NULL,NULL,&cardno,NULL);
		DmDatabaseInfo(cardno,id,
			NULL,NULL,NULL,
			NULL,NULL,NULL,
			NULL,NULL,NULL,
			&type,&creator);
		if(type == 'appl'){
			link->appcardno = cardno;
			link->appid = id;
		}
		if(type == 'DATA'){
			datadb = db;
			link->datacardno = cardno;
			link->dataid = id;
		}
		db = DmNextOpenDatabase(db);
	}
	if(link->appid == NULL){ // no application found
		return;
	}

	if(datadb){
		n = DmNumRecords(datadb);
		for(i=0;i<n;i++){
			// look for a record under modification,
			// where the 'busy' bit is set
			DmRecordInfo(datadb,i,&attr,NULL,NULL);
			if((attr & dmRecAttrBusy) && !(attr & dmRecAttrDelete)){
				link->recordno = i;
				break;
			}
		}
		if(i >= n){ // no open record
//			StrNCopy(link->pattern,str,16);
//			link->pattern[15] = '\0';
		}
	}
#ifdef XXXXX
	if(pref.linkstackindex+1 < MAXLINK){
		pref.linkstackindex++;
	}
	else {
		for(i=0;i<pref.linkstackindex;i++){
			pref.linkstack[i] = pref.linkstack[i+1];
		}
	}
	pref.linkstackmax = pref.linkstackindex;
#endif
	SetWikiPreferences(&pref);
}

void LinkAction(LinkActionType action)
{
	WikiPref pref;
	Link *link;
	int i;

	switch(action){
	case LINKJUMP:
		SaveLink();
		GetWikiPreferences(&pref,true);
		if(pref.linkstackindex+1 < MAXLINK){
			pref.linkstackindex++;
		}
		else {
			for(i=0;i<pref.linkstackindex;i++){
				pref.linkstack[i] = pref.linkstack[i+1];
			}
		}
		pref.linkstackmax = pref.linkstackindex;
		break;
	case LINKFORWARD:
		GetWikiPreferences(&pref,true);
		if(pref.linkstackindex >= pref.linkstackmax ||
		   pref.linkstackindex+1 >= MAXLINK) return;
		pref.linkstackindex++;
		break;
	case LINKBACKWARD:
		GetWikiPreferences(&pref,true);
		if(pref.linkstackindex <= 0) return;
		if(pref.linkstackindex == pref.linkstackmax){
			SaveLink();
			GetWikiPreferences(&pref,false);
		}
		pref.linkstackindex--;
	}

	SetWikiPreferences(&pref);
}

